Redmine - Defect #6350

New Gantt charts : 500 error when no issue have a due date
2010-09-10 06:34 - Rodrigo Guerrero

Status: Closed Start date: 2010-09-10
Priority: High Due date:

Assignee: % Done: 0%
Category: Gantt Estimated time: 0.00 hour
Target version:

Resolution: Fixed Affected version:

Description

Eric, | update redmine and show me this error with | try to see the gantt:

Processing GanttsController#show (for 192.168.0.100 at 2010-09-10 08:58:10) [GET]
Parameters: {"project_id"=>"TT-09-637-F", "action"=>"show", "controller"=>"gantts"}

Rendering template within layouts/base

Rendering gantts/show

ActionView: :TemplateError (undefined method “<=' for nil:NilClass) on line #155 of app/views/gantt
s/show.html.erb:

152:

153: <% top = headers_height + 10 %>

154:

155: <%= Qgantt.lines(:top => top, :zoom => zoom, :g_width => g_width ) %>

156:

157: <%

158: #

lib/redmine/helpers/gantt.rb:301:in "line_for_project'

lib/redmine/helpers/gantt.rb:172:in "render_project'

lib/redmine/helpers/gantt.rb:194:in "render_project'

lib/redmine/helpers/gantt.rb:193:in "render_project'

lib/redmine/helpers/gantt.rb:151:in "lines'

app/views/gantts/show.html.erb:155

app/controllers/gantts_controller.rb:26

app/controllers/gantts_controller.rb:25:in " show'

passenger (2.2.9) lib/phusion_passenger/rack/request_handler.rb:92:in ‘process_request'

passenger (2.2.9) lib/phusion_passenger/abstract_request_handler.rb:207:in "main_loop'

passenger (2.2.9) lib/phusion_passenger/railz/application_spawner.rb:400:in "~ start_request_han
dler'

passenger (2.2.9) lib/phusion_passenger/railz/application_spawner.rb:351:in “handle_spawn_appl
ication'

passenger (2.2.9) lib/phusion_passenger/utils.rb:184:in "“safe_fork'

passenger (2.2.9) lib/phusion_passenger/railz/application_spawner.rb:349:in “handle_spawn_appl
ication'

passenger (2.2.9) lib/phusion_passenger/abstract_server.rb:352:in "_ send_ '

passenger (2.2.9) lib/phusion_passenger/abstract_server.rb:352:in ‘main_loop'

passenger (2.2.9) lib/phusion_passenger/abstract_server.rb:196:in 'start_synchronously'
passenger (2.2.9) lib/phusion_passenger/abstract_server.rb:163:in "start'

passenger (2.2.9) lib/phusion_passenger/railz/application_spawner.rb:209:in ~start'
passenger (2.2.9) lib/phusion_passenger/spawn_manager.rb:262:in "~ spawn_rails_application'
passenger (2.2.9) lib/phusion_passenger/abstract_server_collection.rb:126:1in "~ lookup_or_add'
passenger (2.2.9) lib/phusion_passenger/spawn_manager.rb:256:in "~ spawn_rails_application'
passenger (2.2.9) lib/phusion_passenger/abstract_server_collection.rb:80:in "“synchronize'
passenger (2.2.9) lib/phusion_passenger/abstract_server_collection.rb:79:in "~synchronize'
passenger (2.2.9) lib/phusion_passenger/spawn_manager.rb:255:in "~ spawn_rails_application'
passenger (2.2.9) lib/phusion_passenger/spawn_manager.rb:154:in "~ spawn_application'
passenger (2.2.9) lib/phusion_passenger/spawn_manager.rb:287:in "~handle_spawn_application'
passenger (2.2.9) lib/phusion_passenger/abstract_server.rb:352:in *_ _send_ '

passenger (2.2.9) lib/phusion_passenger/abstract_server.rb:352:in ‘main_loop'

passenger (2.2.9) lib/phusion_passenger/abstract_server.rb:196:in "start_synchronously'
Rendering /Rails/redmine/public/500.html (500 Internal Server Error)

Related issues:
Related to Redmine - Feature #6276: Gantt Chart rewrite Closed
Has duplicate Redmine - Defect #6387: TemplateError when viewing gantt chart ... Closed

2010-09-03
2010-09-14

Associated revisions

Revision 4184 - 2010-09-26 19:35 - Eric Davis

Revert "Fixed: gantt broken when no due date on project issues and versions."
It broke the tests for overdue projects and isn't a good way to fix #6350
because it makes an assumption that a project is due Today and will still

error if issue tracking is disabled.

This reverts commit a7fd592db4037d635d04ca5ce3f01d0af3f0c8ae. (r4178)

Revision 4276 - 2010-10-22 22:32 - Jean-Philippe Lang
Adds a failing test for #6350.

Revision 4280 - 2010-10-23 00:13 - Jean-Philippe Lang

Fixed: error on gantt when no issue have a due date (#6350).

History

#1 - 2010-09-10 14:22 - Anonymous
- File gantt_no_due_date_fix.diff added

| can confirm this error. It happens when none of the issues in a project have a due date set.

| attached a quick patch i made to solve the problem. Seem to work fine for me, and | ran the test suite, no strange errors.

#2 - 2010-09-10 16:38 - Eric Davis

- Category set to Gantt

- Status changed from New to 7

- Target version set to 1.1.0

- Affected version (unused) set to devel

Pieter Nicolai wrote:

| can confirm this error. It happens when none of the issues in a project have a due date set.

Thanks, | was wondering what would cause it.

#3 - 2010-09-10 16:39 - 000 010
- % Done changed from 0 to 50

#4 - 2010-09-10 16:39-000 00
- % Done changed from 50 to 0

#5 - 2010-09-12 10:29 - Jean-Baptiste Barth

- Subject changed from Problem with new Gantt to New Gantt charts : 500 error when no issue have a due date

#6 - 2010-09-16 03:24 - Mischa The Evil

| can confirm this error after the Gantt-rewrite. The attached patch by Pieter Nicolai solves the issue.

#7 - 2010-09-20 13:51 - Maciej Czub

Can somebody apply attached patch to trunk, please?

#8 - 2010-09-26 18:01 - Jean-Baptiste Barth

- Assignee changed from Eric Davis to Jean-Philippe Lang
A patch has been applied in r4178, but it breaks Project#overdue?. See http:/ci.finn.de/builds/1-8-7_redmine-trunk_sqlite3/4178 (second one, the first
one is stupid-simple to fix).

Either we keep this solution but with this modification :

diff --git a/app/models/project.rb b/app/models/project.rb
index 29be68c..e86d246 100644
-—— a/app/models/project.rb
+++ b/app/models/project.rb
@@ -438,9 +438,8 @@ class Project < ActiveRecord::Base
[
issues.maximum ('due_date"'),
shared_versions.collect (&:effective_date),
= shared_versions.collect {|v| v.fixed_issues.maximum('due_date')},
= Date.today
= ].flatten.compact .max
shared_versions.collect {|v| v.fixed_issues.maximum('due_date')}
].flatten.compact.max || Date.today

+ +

end
end

Or we revert it and find another solution (maybe Pieter's patch?).

Any thought about this ? (Jean-Philippe especially)

#9 - 2010-09-26 18:32 - Eric Davis

- Assignee changed from Jean-Philippe Lang to Eric Davis

A problem with r4178 is that it will fail and return a nil if the issue tracking module isn't enabled.

I've been thinking about it and | think it would be best to add actual Start Date and End Date fields to projects, instead of calculating them or assuming
they are 'today'.

#10 - 2010-09-26 19:32 - Eric Davis

I'm reverting r4178 for now. With it breaking the tests, | would have a hard time releasing 1.0.2 today.
#11 - 2010-09-26 22:52 - Jean-Philippe Lang
Eric Davis wrote:
I've been thinking about it and | think it would be best to add actual Start Date and End Date fields to projects, instead of calculating them or

assuming they are 'today'.

Project start and due dates wouldn't solve the problem as they may not be set.
Why not simply fix the gantt so that it handles nil values?

#12 - 2010-09-26 22:54 - Anonymous

Eric, with Start and End Date fields for projects would a issue/version with a due date past that still show up in the gantt chart? If so that would be a
nice solution.

My patch will, in absence of a calculated end date, set the end date as far as the gantt view filter is set to. A more structural approach as you
suggests with project fields might be better.

#13 - 2010-09-26 23:20 - Anonymous
Jean-Philippe Lang wrote:
Project start and due dates wouldn't solve the problem as they may not be set.

Why not simply fix the gantt so that it handles nil values?

True, | would then propose to apply my patch to the trunk as a quick fix. That way the trunk is not broken anymore. The idea of project start and end
fields is still interesting though, even outside the scope of the gantt chart.

#14 - 2010-09-26 23:44 - Eric Davis

Jean-Philippe Lang wrote:

Project start and due dates wouldn't solve the problem as they may not be set.
Why not simply fix the gantt so that it handles nil values?
https://www.redmine.org/projects/redmine/repository/svn/revisions/4178
http://ci.finn.de/builds/1-8-7_redmine-trunk_sqlite3/4178
https://www.redmine.org/projects/redmine/repository/svn/revisions/4178
https://www.redmine.org/projects/redmine/repository/svn/revisions/4178

Yea, the Gantt will need to handle nil values no matter how Project dates are calculated.

#15 - 2010-10-22 20:40 - Vincent Polite
Hello all. | ran into this issue as well, installing a new Redmine Server. | was wondering what the proposed course of action and/or recommended fix
is in terms of resolving this?

#16 - 2010-10-22 22:26 - Jean-Philippe Lang
- Priority changed from Normal to High

Test added in r4276.
#17 - 2010-10-22 23:25 - Eric Davis
Marked the failed test as pending in r4278. Tests should never fail on a commit.
Vincent Polite wrote:
Hello all. |ran into this issue as well, installing a new Redmine Server. | was wondering what the proposed course of action and/or

recommended fix is in terms of resolving this?

You will need to wait for it to be fixed. And you shouldn't be running trunk since trunk is only meant for development and will have bugs at times (like
now).

#18 - 2010-10-23 00:08 - Jean-Philippe Lang
- Status changed from 7 to Closed

- Assignee deleted (Eric Davis)

- Target version deleted (1.1.0)

- Resolution set to Fixed

Fixed in r4280.

Files

gantt_no_due_date_fix.diff 1.05 KB 2010-09-10 Anonymous
